#!/bin/bash
#

#
# ؿ include
# 

if [ -z ${JVO_DEV} ]; then
   echo "you must set JVO_DEV"
   exit 1
fi

. ${JVO_DEV}/build/${HOSTARCH}/share/jvo-tools/common/function.sh
. ${JVO_DEV}/build/${HOSTARCH}/share/jvo-tools/qso-study/agn-dataset-func.sh

c__init_pfile

#
# եƤ齪λ
#
trap "clean0" EXIT
trap "clean1" INT TERM 

function clean0
{
   local code=$?
   if [ "$g_help" == "1" ]; then
      exit 1
   fi

   c__clean

   if [ "$g_clean" == "1" ]; then
      clean
   fi

   echo "# code=$code"
   exit $code
}

function clean1
{
   local code=$?
   echo "# code=$code"
   exit $code
}

function clean {
   if [ "$c_tdir" == $(pwd) ]; then
      return 0
   fi
}

#
#
#
function start
{
   #
   # ȥǥ쥯ȥ
   # եѥʤɤ꤬ǹԤΤǡ
   # ˥ؤν񤭽Ф򤷤ʤȡ
   #
   start_common
}


#
#
#
function finalize
{
   finalize_common
}

#
#
#
function check_args
{
   check_args_common
}


#
# UKIDSS ǡ򸡺
#
function search_ukidss
{
    #
    # SQL
    #
    cat > .tmp-ukidss.$$.sql <<EOF
SELECT  TOP ${g_search_limit} OFFSET @offset@ 
        ID, SOURCEID, RA, DEC, SURVEY, 
        yapermag3,   yppErrBits,
        j_1apermag3, j_1ppErrBits, 
        hapermag3,   hppErrBits, 
        kapermag3,   kppErrBits,
        yapermag3err, 
        j_1apermag3err, 
        hapermag3err, 
        kapermag3err, mergedClass
FROM    ivo://jvo/ukidss:catalog_dr9 AS t
WHERE   REGION('CIRCLE @ra@ @dec@ @rad@')
        AND SURVEY = 'las'
        AND (mergedClass = 1 OR mergedClass = -3)
ORDER BY ID
EOF

    #
    # ${g_search_limit} 鷺ļ롣
    #
    local offset=0
    local status=
    /bin/rm -f ukidss_*.psv

    while [ "0" == "0" ]; do
        c__log F:$FUNCNAME $LINENO "offset=$offset"

        cat .tmp-ukidss.$$.sql | \
            awk '{gsub("@ra@", ra); gsub("@dec@", dec); 
                  gsub("@rad@", rad); gsub("@offset@", offset); \
                  print $0}' \
        ra=$g_ra dec=$g_dec rad=$g_rad offset=$offset > ukidss.sql
    
        #
        #
        #
        for try in $(seq 1 30); do
           #
           # Search
           #
           /bin/rm -f ukidss.xml
           if ! jc -v search -i ukidss.sql -o ukidss.xml > .tmp.$$.log 2>&1; then
              echo "*** error : ukidss data search failed [1]."
              cat .tmp.$$.log | tee -a $c_log
              status="ERROR"
              c__log F:$FUNCNAME $LINENO "data search error : retry ($try)"
              c__log F:$FUNCNAME $LINENO "sleep $try minutes"
              sleep ${try}m
              continue
           fi

           if [ ! -e ukidss.xml ]; then
              echo "*** error : ukidss data search failed [2]."
              cat .tmp.$$.log | tee -a $c_log
              status="ERROR"
              c__log F:$FUNCNAME $LINENO "data search error : retry ($try)"
              c__log F:$FUNCNAME $LINENO "sleep $try minutes"
              sleep ${try}m
              continue
           fi

           #
           # vot2psv
           #
           if ! jc -v vot2xsv -F\| -o ukidss_${offset}.psv ukidss.xml > .tmp.$$.log 2>&1; then
              echo "*** error : votable select failed."
              cat .tmp.$$.log | tee -a $c_log
              return 1
           fi

           #
           # 顼å
           #
           status=$(cat ukidss_${offset}.psv | grep "INFO: QUERY_STATUS=" | awk -F= '{print $2}')
           if [ "$status" != "ERROR" ]; then
              break
           fi
           c__log F:$FUNCNAME $LINENO "data search error : retry ($try)"
           c__log F:$FUNCNAME $LINENO "sleep $try minutes"
           sleep ${try}m
        done

        if [ "$status" == "ERROR" ]; then
            echo "*** error : ukidss data search failed. [3]"
	    return 1
        fi

        #
        # ̿Υå
        #
        count=$(cat ukidss_${offset}.psv | grep "INFO: RECORD_NUM=" | awk -F= '{print $2}')
	if [ "$count" -lt "$g_search_limit" ]; then
	    break;
	fi
        offset=$(( offset + g_search_limit ))
    done

    cat ukidss_*.psv | grep -v "#" > ukidss.psv
    local n=$(cat ukidss.psv | wc -l)
    c__log F:$FUNCNAME $LINENO "number of data = $n"
    if [ "$n" -lt 0 ]; then
       c__log F:$FUNCNAME $LINENO "no data found for ukidss."      
       return 2
    fi
    if [ "$n" -lt 10 ]; then
       c__log F:$FUNCNAME $LINENO "number of data is too small."      
       return 2
    fi

    #
    # K.cat ɬפʥǡȴФ (id, ra, dec, mag_K (AB))
    #
    cat ukidss.psv | grep -v "^#" | awk -F\| '{if($6>0&&$7<=255) print $2,$3,$4,$6+0.634}' > Y.cat
    cat ukidss.psv | grep -v "^#" | awk -F\| '{if($8>0&&$9<=255) print $2,$3,$4,$8+0.91}' > J.cat
    cat ukidss.psv | grep -v "^#" | awk -F\| '{if($10>0&&$11<=255) print $2,$3,$4,$10+1.39}' > H.cat
    cat ukidss.psv | grep -v "^#" | awk -F\| '{if($12>0&&$13<=255) print $2,$3,$4,$12+1.85}' > K.cat

    cat ukidss.psv | grep -v "^#" | awk -F\| '{ 
       if($6<0 || $7>255) {
          Y=99;
       } else {
          Y=$6+0.634;
       };

       if($8<0 || $9>255) {
          J=99;
       } else {
          J=$8+0.91;
       };

       if($10<0 || $11>255) {
          H=99;
       } else {
          H=$10+1.39;
       };

       if($12<0 || $13>255) {
          K=99;
       } else {
          K=$12+1.85;
       };

       if($14<0 || Y==99) {
           $14=99;
       }
       if($15<0 || J==99) {
           $15=99;
       }
       if($16<0 || H==99) {
           $16=99;
       }
       if($17<0 || K==99) {
           $17=99;
       }

       if(Y<99 || J<99 || H<99 || K<99) {
          printf("%s %s %s  %lf %lf %lf %lf  %lf %lf %lf %lf\n", $2,$3,$4,Y,J,H,K, $14,$15,$16,$17);
       }

    }' > YJHK.cat
}

#
# UKIDSS ǡ򸡺
#
function search_ukidss_2
{
    #
    # SQL
    #
    cat > .tmp-ukidss.$$.sql <<EOF
SELECT  TOP ${g_search_limit} OFFSET @offset@ 
        ID, SOURCEID, RA, DEC, SURVEY, 
        yapermag3,   yppErrBits,
        j_1apermag3, j_1ppErrBits, 
        hapermag3,   hppErrBits, 
        kapermag3,   kppErrBits,
        yapermag3err, 
        j_1apermag3err, 
        hapermag3err, 
        kapermag3err, mergedClass
FROM    ivo://jvo/ukidss:catalog_dr9 AS t
WHERE   REGION('CIRCLE @ra@ @dec@ @rad@')
        AND SURVEY = 'las'
        AND (mergedClass = 1 OR mergedClass = -3)
ORDER BY ID
EOF

    #
    # ${g_search_limit} 鷺ļ롣
    #
    local offset=0
    local status=
    local class=jp.ac.nao.jvo.skynode.client.VODataSearch
#   local url=http://jvo.nao.ac.jp/skynode/do/tap/ukidss
    local url=http://jvox.vo.nao.ac.jp:8060/skynode/do/tap/ukidss

    /bin/rm -f ukidss_*.psv

    while [ "0" == "0" ]; do
        c__log F:$FUNCNAME $LINENO "offset=$offset"

        cat .tmp-ukidss.$$.sql | \
            awk '{gsub("@ra@", ra); gsub("@dec@", dec); 
                  gsub("@rad@", rad); gsub("@offset@", offset); \
                  print $0}' \
        ra=$g_ra dec=$g_dec rad=$g_rad offset=$offset > ukidss.sql
    
        #
        #
        #
        for try in $(seq 1 30); do
           #
           # Search
           #
           /bin/rm -f ukidss.xml
#          if ! jc -v search -i ukidss.sql -o ukidss.xml > .tmp.$$.log 2>&1; then
           if ! ${g_java} ${class} -u ${url} -a ukidss.sql -O ukidss.xml > .tmp.$$.log 2>&1; then
              echo "*** error : ukidss data search failed [1]."
              cat .tmp.$$.log | tee -a $c_log
              status="ERROR"
              c__log F:$FUNCNAME $LINENO "data search error : retry ($try)"
              c__log F:$FUNCNAME $LINENO "sleep $try minutes"
              sleep ${try}m
              continue
           fi

           if [ ! -e ukidss.xml ]; then
              echo "*** error : ukidss data search failed [2]."
              cat .tmp.$$.log | tee -a $c_log
              status="ERROR"
              c__log F:$FUNCNAME $LINENO "data search error : retry ($try)"
              c__log F:$FUNCNAME $LINENO "sleep $try minutes"
              sleep ${try}m
              continue
           fi

           #
           # vot2psv
           #
           if ! jc -v vot2xsv -F\| -o ukidss_${offset}.psv ukidss.xml > .tmp.$$.log 2>&1; then
              echo "*** error : votable select failed."
              cat .tmp.$$.log | tee -a $c_log
              return 1
           fi

           #
           # 顼å
           #
           status=$(cat ukidss_${offset}.psv | grep "INFO: QUERY_STATUS=" | awk -F= '{print $2}')
           if [ "$status" != "ERROR" ]; then
              break
           fi
           c__log F:$FUNCNAME $LINENO "data search error : retry ($try)"
           c__log F:$FUNCNAME $LINENO "sleep $try minutes"
           sleep ${try}m
        done

        if [ "$status" == "ERROR" ]; then
            echo "*** error : ukidss data search failed. [3]"
	    return 1
        fi

        #
        # ̿Υå
        #
        count=$(cat ukidss_${offset}.psv | grep "INFO: RECORD_NUM=" | awk -F= '{print $2}')
	if [ "$count" -lt "$g_search_limit" ]; then
	    break;
	fi
        offset=$(( offset + g_search_limit ))
    done

    cat ukidss_*.psv | grep -v "#" > ukidss.psv
    local n=$(cat ukidss.psv | wc -l)
    c__log F:$FUNCNAME $LINENO "number of data = $n"
    if [ "$n" -lt 0 ]; then
       c__log F:$FUNCNAME $LINENO "no data found for ukidss."      
       return 2
    fi
    if [ "$n" -lt 10 ]; then
       c__log F:$FUNCNAME $LINENO "number of data is too small."      
       return 2
    fi

    #
    # K.cat ɬפʥǡȴФ (id, ra, dec, mag_K (AB))
    #
    cat ukidss.psv | grep -v "^#" | awk -F\| '{if($6>0&&$7<=255) print $2,$3,$4,$6+0.634}' > Y.cat
    cat ukidss.psv | grep -v "^#" | awk -F\| '{if($8>0&&$9<=255) print $2,$3,$4,$8+0.91}' > J.cat
    cat ukidss.psv | grep -v "^#" | awk -F\| '{if($10>0&&$11<=255) print $2,$3,$4,$10+1.39}' > H.cat
    cat ukidss.psv | grep -v "^#" | awk -F\| '{if($12>0&&$13<=255) print $2,$3,$4,$12+1.85}' > K.cat

    cat ukidss.psv | grep -v "^#" | awk -F\| '{ 
       if($6<0 || $7>255) {
          Y=99;
       } else {
          Y=$6+0.634;
       };

       if($8<0 || $9>255) {
          J=99;
       } else {
          J=$8+0.91;
       };

       if($10<0 || $11>255) {
          H=99;
       } else {
          H=$10+1.39;
       };

       if($12<0 || $13>255) {
          K=99;
       } else {
          K=$12+1.85;
       };

       if($14<0 || Y==99) {
           $14=99;
       }
       if($15<0 || J==99) {
           $15=99;
       }
       if($16<0 || H==99) {
           $16=99;
       }
       if($17<0 || K==99) {
           $17=99;
       }

       if(Y<99 || J<99 || H<99 || K<99) {
          printf("%s %s %s  %lf %lf %lf %lf  %lf %lf %lf %lf\n", $2,$3,$4,Y,J,H,K, $14,$15,$16,$17);
       }

    }' > YJHK.cat
}


#
# AGN εΥͭ(Ωγ?)׻
#
function cal_earea_ukidss
{
   local step_sec=$(cosmic-distance -z ${g_redshift} --length ${g_step_dr}  | \
         grep "separation angle" | awk '{print $4}')

   for band in Y J H K; do 
#  for band in K; do 
      cat ${band}.cat | grep -v "#" | awk '{print $2,$3}' > radec_${band}.dat
      #
      # earea_${band}.datearea-logx_${band}.dat ˷̤¸
      #
      cal_earea_common $g_ra $g_dec $g_mask $step_sec radec_${band}.dat $band 10
   done
}

#
#
# ʬŪʥǡη»ʤå
#
# check_coverage_ukidss <badfrac_max>
#
function check_coverage_ukidss
{
   #
   #
   #
   local badfrac_max=$1
   local r_5Mpc=$(cosmic-distance -z ${g_redshift} --length 5.0 | grep "separation angle" | awk '{print $4}')
   #
   # UKIDSS
   #
   local band=
   for band in Y J H K; do
#  for band in K; do
      check_coverage_common ${badfrac_max} ${r_5Mpc} ${band}
   done
}


#
#
#
function cal_rho0_ukidss
{
   local band=
   for band in Y J H K; do
#  for band in K; do
      cat ${band}.cat | grep -v "#" | awk '{print $4}' > .mag.$$.dat
      cal_rho0_common .mag.$$.dat ${band} $g_redshift
   done
}

#
#
#
function cal_Bqg_ukidss
{
   local band=
   for band in Y J H K; do
#   for band in K; do
      #
      #
      #
      local rho0=$(cat rho0-${band}.dat | grep -v "^#" | awk '{print $2}')
      local scale=${g_bqg_scale}  # Mpc
      local fn_hist=hist1_${band}.dat
      #
      # Bqg ׻̤ Bqg_${band}.dat ¸롣
      #
      cal_Bqg_common ${fn_hist} ${scale} ${g_bg_rmin} ${g_bg_rmax} ${rho0} ${band}
   done
}

#
# agn_stat
#
function agn_stat_ukidss
{
   local qso=${g_name}

   #
   #  agn-info.dat
   #
   local absmag=${g_absmag}
   if [ "$absmag" == "" ]; then
      absmag=99
   fi

   #
   #
   #
   for band in Y J H K; do
#  for band in K; do
      local fn_hist=hist1_${band}.dat
      #
      # ̤ agn_stat_${band}.dat ¸롣
      #
      local args="${fn_hist} ${g_fg_rmin} ${g_fg_rmax} ${g_bg_rmin} ${g_bg_rmax}"
      args="${args} ${qso} ${g_redshift} ${absmag} ${band}"
      agn_stat_common ${args}
   done
}


#
# ̤ hist1_${band}.dat
# earea_${band}.dat, ${band}.cat ɬ
#
function mk_hist1_ukidss
{
   #
   #
   #
   local band=
   for band in Y J H K; do
#  for band in K; do
      #
      # ra,dec
      #
      cat ${band}.cat | grep -v "#" | awk '{print $2,$3}' > .radec.$$.dat
      local dth=$(cosmic-distance -z ${g_redshift} --length ${g_step_dr} | \
            grep "separation angle" | awk '{print $4}')
      #
      # ̤ hist_${band}.dat, hist-logx_${band}.dat ¸
      #
      local args=".radec.$$.dat ${g_ra} ${g_dec} ${dth} ${g_mask}"
      args="${args} ${g_redshift} ${band}"
      mk_hist_common ${args}
      mv hist_${band}.dat hist1_${band}.dat
   done
}

#
# ̤ hist2_${band}.dat
# earea_${band}.dat, ${band}.cat ɬ
#
function mk_hist2_ukidss
{
   #
   #
   #
   local band=
   for band in Y J H K; do
#  for band in K; do
      #
      # ra,dec
      #
      mth=$(cat fit-maghist-${band}.dat | grep -v "#" | head -1 | awk '{print $4}')
      cat ${band}.cat | grep -v "#" | awk '{if($4<mth) print $2,$3}' mth=$mth > .radec.$$.dat
      local dth=$(cosmic-distance -z ${g_redshift} --length ${g_step_dr} | \
            grep "separation angle" | awk '{print $4}')
      c__log F:$FUNCNAME $LINENO "mth=$mth"
      #
      # ̤ hist_${band}.dat, hist-logx_${band}.dat ¸
      #
      local args=".radec.$$.dat ${g_ra} ${g_dec} ${dth} ${g_mask}"
      args="${args} ${g_redshift} ${band}"
      mk_hist_common ${args}
      mv hist_${band}.dat hist2_${band}.dat
   done
}

#
#
#
function graphic_ukidss
{
   local rad1Mpc=$(cosmic-distance -z ${g_redshift} --length 1.0 | \
               grep "separation angle" | awk '{print $4/60/60}')
   for band in Y J H K; do
#  for band in K; do
      graphic_common ${g_ra} ${g_dec} ${g_rad} ${rad1Mpc} ${band}
   done
}

#
#
#
function summary_ukidss
{
   summary_common ${g_name} ${g_ra} ${g_dec} ${g_rad} ${g_redshift} "Y,J,H,K"
#  summary_common ${g_name} ${g_ra} ${g_dec} ${g_rad} ${g_redshift} "K"
}

#
#
#
function skip_all
{
   g_skip_search=1
   g_skip_earea=1
   g_skip_hist=1
   g_skip_limit=1
   g_skip_graphic=1
   g_skip_summary=1
}

#
# ѿ
#
g_ra=
g_dec=
g_rad=
g_name=
g_redshift=
g_absmag=

g_skip_search=0
g_skip_earea=0
g_skip_mkhist=0
g_skip_limit=0
g_skip_graphic=0
g_skip_summary=0
g_search_limit=5000
g_mask=4.0
g_clean=1
g_share=${JVO_DEV}/build/${HOSTARCH}/share/jvo-tools/qso-study

g_bqg_scale=0.4
g_fg_rmin=0.1
g_fg_rmax=1.0
g_bg_rmin=3.0
g_bg_rmax=5.0

g_step_dr=0.2 
g_dr_100=$(cosmic-distance -z ${g_redshift} -t 100  | grep "comoving separation distance" | awk '{print $5}')
g_dtag=test

g_java="java -Djvo.default.properties=${JVO_DEV}/conf/grid/jvo.properties -Djvo.properties=${HOME}/grid_engine/etc/jvo.properties"


if [ "$J_NOCLEAN" == "1" ]; then
   g_clean=0
fi

while [ $# -gt 0 ]; do

   case $1 in
   -h|--help)
      echo "Usage: ${0##/*/} -r <ra> -d <dec> --rad <rad> -z <redshift> [OPTIONS]"
      echo "Required Args are:"
      echo "   -r, --ra            RA (deg)"
      echo "   -d, --dec           Dec (deg)"
      echo "     , --rad           radius (deg)"
      echo "   -z, --redshift      redshift"
      echo "   -n, --name          name of the AGN"
      echo "   -m, --mask          mask region radius (arcsec)"
      echo "Options are:"
      echo "   -t, --tag           tag name"
      echo "   -w, --wdir          work direcotyr"
      echo "     , --no-clean      don't remove temp files"
      echo "     , --graphic       skip all other than creating graphic"
      echo "     , --skip-data     skip data search"
      echo "   -h, --help          shows this help"
      exit 1
      ;;

   -r|--ra)
      g_ra=$2
      shift 2
      ;;

   -d|--dec)
      g_dec=$2
      shift 2
      ;;

   --rad)
      g_rad=$2
      shift 2
      ;;

   -z|--redshift)
      g_redshift=$2
      shift 2
      ;;

   -n|--name)
      g_name=$2
      shift 2
      ;;

   -m|--mask)
      g_mask=$2
      shift 2
      ;;

   -w|--wdir)
      c_wdir=$2
      shift 2
      ;;

   --search)
      skip_all
      g_skip_search=0
      shift 1
      ;;

   --mk-hist)
      skip_all
      g_skip_mkhist=0
      shift 1
      ;;

   --graphic)
      skip_all
      g_skip_graphic=0
      shift 1
      ;;

   --skip-data)
      g_skip_search=1
      shift
      ;;

   --no-clean)
      g_clean=0
      export J_NOCLEAN=1
      shift
      ;;

   *)
      echo "### warning : unkonwn option : $1" 
      shift
      ;;
   esac
done


#
# ¹Գϻν
#
start

#
#
#
if ! check_args; then
   c__error MAIN F:$LINENO "insufficient argument(s)."
fi


#
#
#
if [ "$g_skip_search" != 1 ]; then
   c__log MAIN $LINENO "# search"
   if ! search_ukidss_2; then
      skip_all
      g_skip_summary=0
   fi
fi

#
#
#
if [ "$g_skip_earea" != 1 ]; then
   c__log MAIN $LINENO "# earea"
   cal_earea_ukidss

   c__log MAIN $LINENO "# coverage"
   check_coverage_ukidss 0.2
fi

#
#
#
if [ "$g_skip_hist" != 1 ]; then
   c__log MAIN $LINENO "# mk_hist1"
   mk_hist1_ukidss
fi

#
#
#
if [ "$g_skip_limit" != 1 ]; then

   c__log MAIN $LINENO "# rho0"
   cal_rho0_ukidss

   c__log MAIN $LINENO "# Bqg"
   cal_Bqg_ukidss

   c__log MAIN $LINENO "# stat"
   agn_stat_ukidss
fi

if [ "$g_skip_hist" != 1 ]; then
   c__log MAIN $LINENO "# mk_hist2"
   mk_hist2_ukidss
fi


#
#
#
if [ "$g_skip_graphic" != 1 ]; then
   graphic_ukidss
fi

#
# λ
#
finalize

#
#
#
if [ "$g_skip_summary" != 1 ]; then
   summary_ukidss
fi

exit 0
