#include <stdio.h>
#include <math.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include "opt.h"

#define MAX_FILE 100000
#define MAX_BIN  100

char *g_fn_list;
int g_num_file = 0;
int g_num_bin = 0;
char **g_fn_hist;

void read();


/**
 *
 */
int main(int argc, char *argv[])
{
    optUsage("[OPTIONS]");
    optrega(&g_fn_list, OPT_VSTRING, 'l', "list", "list of density hist file");
    opt(&argc, &argv);

    //printf("# read\n");
    read();
    exit(0);
}


/**
 *
 */
void read() 
{
    int i, j, n;
    FILE *fp;
    char line[1000];
    int hist;
    int *s0;
    double *r, *s1, *s2, *s3, *s4, *s5;
    double hist_cor, area, dens, err, bad_frac;
    double cor, bad, den;

    //
    // եΥꥹȤɤ߹
    //
    printf("# fn_list=%s\n", g_fn_list);

    fp = fopen(g_fn_list, "r");
    n = 0;
    g_fn_hist = (char **) calloc(MAX_FILE, sizeof(char *));
    while(! feof(fp)) {
        g_fn_hist[n] = (char *) calloc(100, sizeof(char));
        fscanf(fp, "%s", g_fn_hist[n]);
        //printf("# %s\n", g_fn_hist[n]);
        n++;
        if(n >= MAX_FILE) {
            printf("# number of files exceeds the limit (=%d).\n", MAX_FILE);
            break;
        }
    }
    fclose(fp);
    //
    //
    //
    s0 = (int *) calloc(MAX_BIN, sizeof(int));
    s1 = (double *) calloc(MAX_BIN, sizeof(double));
    s2 = (double *) calloc(MAX_BIN, sizeof(double));
    s3 = (double *) calloc(MAX_BIN, sizeof(double));
    s4 = (double *) calloc(MAX_BIN, sizeof(double));
    s5 = (double *) calloc(MAX_BIN, sizeof(double));
    r = (double *) calloc(MAX_BIN, sizeof(double));
    //
    // ҥȥեɤ
    //
    g_num_bin = MAX_BIN;
    g_num_file = 0;
    for(i = 0; i < n; i++) {
        //printf("# %d/%d\n", i+1, n);
        fflush(stdout);
        fp = fopen(g_fn_hist[i], "r");
        if(fp == NULL) {
            continue;
        }
        g_num_file++;
        j = 0;
        while(! feof(fp)) {
            fgets(line, 1000, fp);
            if(line[0] == '#') {
                continue;
            }
            //printf("%s\n", line);
            sscanf(line, "%*d %lf %d %lf %lf %lf %lf %lf",
                   &r[j], &hist, &hist_cor, &area, &dens, &err, &bad_frac);

            if(hist > 0) {
                cor = hist_cor / (double) hist;
            } else {
                cor = 1;
            }

            //
            // hist_cor = hist / (1 - bad_frac)
            // area :  (bad/mask ޤ)
            // earea = area * (1 - bad_frac)
            // dens = hist / earea = hist_cor / area
            //
            s0[j] += hist;
            s1[j] += hist_cor;
            s2[j] += area;

            s3[j] += (hist_cor / area);
            s4[j] += (hist * cor * cor / area / area);
            s5[j] += r[j];
            
            j++;
	    if(j >= MAX_BIN) {
	      break;
	    }

        }
        if(j < g_num_bin) {
            g_num_bin = j;
        }
        fclose(fp);
        ///printf("# num_bin = %d\n", g_num_bin);
    }
    //
    //
    //
    printf("# num_file = %d\n", g_num_file);
    printf("# num_bin = %d\n", g_num_bin);
    fflush(stdout);
    for(j = 0; j < g_num_bin; j++) {    
        if(g_num_file > 0) {
            r[j] = s5[j] / (double) g_num_file;
            den = s3[j] / (double) g_num_file;
            if(s4[j] > 0) {
                err = sqrt(s4[j]) / (double) g_num_file;
            } else {
                err = 0;
            }
        } else {
            r[j] = 0;
            den = 0;
            err = 0;
        }
        if(s1[j] > 0) {
            bad = 1 - s0[j] / s1[j];
        } else {
            bad = 0;
        }
        printf("%d %f %d %f %f %f %f %f\n",
               j, r[j], s0[j], s1[j], s2[j], den, err, bad);
    }

    free(s0);
    free(s1);
    free(s2);
    free(s3);
    free(s4);
    free(s5);
    free(r);
    
}

