/**
 *
 */
package jp.ac.nao.jvo.research.clustering;

import java.util.List;
import java.util.ArrayList;
import java.io.IOException;
import java.io.LineNumberReader;
import java.io.PrintWriter;
import java.io.FileWriter;
import java.io.FileReader;
import java.io.BufferedWriter;

//import nom.tam.fits.Header;

//import jp.ac.nao.jvo.infra.io.JVOFileReader;
//import jp.ac.nao.jvo.infra.io.JVOFileWriter;
//import jp.ac.nao.jvo.infra.log.JVOLogger;

/**
 *
 */
public class CatalogEffectiveArea {
    //
    //
    //
    private static int MAX_SIM = 1000;

    //
    // 濴ɸ (AGN κɸ)
    //
    private double[] center = new double[2];

    //
    // ž (this.center ׻)
    //
    private double[][] rot = new double[3][3];
    
    //
    // Ϥκɸ
    //
    private List<double[]> coordList = new ArrayList<double[]>();

    //
    // Ϥκɸ (pixɸ)
    //
    private List<double[]> coordPixList = new ArrayList<double[]>();

    //
    // ȥޥå
    //
    private CountMap countMap;

    //
    //
    //
    private List<CountMap> zero;
    private List<CountMap> nonZero;
    private List<CountMap> dead;
    private List<CountMap> mask;

    private int totalCount = 0;
    private double totalArea = 0;

    //
    //
    //
    private int nbin = 100;
    private double step;
    private double maskRad = 4.0;
    private int[] count;
    private double[] badFrac;
    private double[] maskFrac;
    private double maskSigma = 10;

    /**
     *
     */
    public CatalogEffectiveArea(double centerRa, double centerDec) {
        //
        //
        //
        this.center[0] = centerRa;
        this.center[1] = centerDec;

        //
        // ž
        //
        double th = (90 - centerDec) / 180. * Math.PI;
        double ph = centerRa / 180. * Math.PI;
        this.rot[0][0] = Math.cos(th) * Math.cos(ph);
        this.rot[0][1] = Math.cos(th) * Math.sin(ph);
        this.rot[0][2] = -Math.sin(th);
        this.rot[1][0] = -Math.sin(ph);
        this.rot[1][1] = Math.cos(ph);
        this.rot[1][2] = 0;
        this.rot[2][0] = Math.sin(th) * Math.cos(ph);
        this.rot[2][1] = Math.sin(th) * Math.sin(ph);
        this.rot[2][2] = Math.cos(th);

        //
        // ղž
        //
    }

    /**
     *
     */
    private void putRaDec(double ra, double dec) {
        double[] coord = new double[2];
        coord[0] = ra;
        coord[1] = dec;
        this.coordList.add(coord);
    }
    
    /**
     *
     */
    public void setMaskRad(double maskRad) {
        this.maskRad = maskRad;
    }

    /**
     *
     */
    public void setStep(double step) {
        this.step = step;
    }

    /**
     *
     */
    public void setMaskSigma(double maskSigma) {
        this.maskSigma = maskSigma;
    }

    /**
     *
     */
    public void read(String fn) throws IOException {

        LineNumberReader in = null;
        try {
            //in = JVOFileReader.open(fn);
            in = new LineNumberReader(new FileReader(fn));
            String line = null;
            while((line = in.readLine()) != null) {
                if(line.startsWith("#")) {
                    continue;
                }
                String[] a = line.split("\\s+");
                if(a.length < 2) {
                    continue;
                }
                double ra, dec;
                try {
                    ra = Double.parseDouble(a[0]);
                    dec = Double.parseDouble(a[1]);
                } catch(NumberFormatException e) {
                    continue;
                }
                putRaDec(ra, dec);
            }

            initCoordPixList();

            //
            //
            //
            //PrintWriter out = JVOFileWriter.open("point.dat");
            PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("point.dat")));


            this.count = new int[this.nbin];
            for(int i = 0; i < this.coordList.size(); i++) {
                double[] pos = this.coordList.get(i);
                double[] pix = this.coordPixList.get(i);
                String s = pos[0] + " " + pos[1] + " " + pix[0] + " " + pix [1];
                out.println(s);
                //
                // arcsec
                //
                double th = Math.acos(pix[2]) / Math.PI * 180. * 60. * 60.;
                int ind = (int) Math.floor(th / this.step);
                if(ind >= 0 && ind < this.nbin) {
                    this.count[ind]++;
                }

            }
            out.close();

        } finally {
            if(in != null) {
                in.close();
            }
        }

    }

    /**
     *  ¤κɸpixɸѴ
     */
    private void initCoordPixList() {
        this.coordPixList.clear();
        for(int i = 0; i < this.coordList.size(); i++) {
            double[] pix1 = radec2xyz(this.coordList.get(i));
            double[] pix2 = rotate(pix1);
            this.coordPixList.add(pix2);
        }
    }

    /**
     *
     */
    private double[] radec2xyz(double[] coord) {
        double ra = coord[0];
        double dec = coord[1];
        double th = (90 - dec) / 180. * Math.PI;
        double ph = ra / 180. * Math.PI;
        double[] p = new double[3];
        p[0] = Math.sin(th) * Math.cos(ph);
        p[1] = Math.sin(th) * Math.sin(ph);
        p[2] = Math.cos(th);
        return p;
    }

    /**
     *
     */
    private double[] rotate(double[] coord) {
        double[] p = new double[3];
        for(int i = 0; i < 3; i++) {
            p[i] = 0;
            for(int j = 0; j < 3; j++) {
                p[i] += this.rot[i][j] * coord[j];
            }
        }
        return p;
    }


    /**
     *
     */
    private void createCountMap() {
        double xmax = -1e20;
        double ymax = -1e20;
        for(int i = 0; i < this.coordPixList.size(); i++) {
            double[] pos = this.coordPixList.get(i);
            if(Math.abs(pos[0]) > xmax) {
                xmax = Math.abs(pos[0]);
            }
            if(Math.abs(pos[1]) > ymax) {
                ymax = Math.abs(pos[1]);
            }
        }
        this.countMap = new CountMap("M", -xmax, xmax, -ymax, ymax, this.coordPixList, true);
    }

    /**
     *
     */
    public List<CountMap> getZeroCountMap() {
        return this.countMap.getZeroCountMap();
    }
    /**
     *
     */
    public List<CountMap> getNonZeroCountMap() {
        return this.countMap.getNonZeroCountMap();
    }

    /**
     *
     */
    private boolean inDeadRegion(double[] pos) {
        if(this.dead == null) {
            return false;
        }
        for(int i = 0; i < this.dead.size(); i++) {
            if(this.dead.get(i).contains(pos)) {
                return true;
            }
        }
        return false;
    }

    /**
     *
     */
    private boolean inMaskRegion(double[] pos) {
        if(this.mask == null) {
            return false;
        }
        for(int i = 0; i < this.mask.size(); i++) {
            if(this.mask.get(i).contains(pos)) {
                return true;
            }
        }
        return false;
    }

    /**
     *
     */
    public double getAverageDensity() {
        if(this.totalArea > 0) {
            return this.totalCount / this.totalArea;   
        } else {
            return 0;   
        }
    }

    /**
     *  this.nonZero ǡ this.totalCount  this.totalArea η׻
     */
    private void setStatFromNonZero() {
        int s1 = 0;
        double s2 = 0;
        for(int i = 0; i < this.nonZero.size(); i++) {
            s1 += this.nonZero.get(i).getCount();
            s2 += this.nonZero.get(i).getArea();
        }
        this.totalCount = s1;
        this.totalArea = s2;
    }

    /**
     *
     */
    private void addAread(double area) {
        this.totalArea = area;
    }
    
    /**
     *
     */
    private void findDeadRegion() {
        //
        //
        //
        this.zero = getZeroCountMap();
        this.nonZero = getNonZeroCountMap();
        //
        //
        //
        setStatFromNonZero();
        if(this.totalArea <= 0) {
            return;
        }
        //
        //
        //
        List<CountMap> dead = new ArrayList<CountMap>();
        List<CountMap> cand = new ArrayList<CountMap>();
        cand.addAll(this.zero);
        //
        // ݥפ dead ΰȽ
        //
        double s1 = this.totalCount;
        double s2 = this.totalArea;
        double s3 = 0;
        int max = 5;
        for(int k = 0; k < max; k++) {
            double dens = s1 / (s2 + s3);
            s3 = 0;
            for(int i = cand.size() - 1; i >= 0; i--) {
                double area = cand.get(i).getArea();
                double nexp = dens * area;
                double nlow = nexp - Math.sqrt(nexp) * 3;
                if(nlow > 0) {
                    if(k == (max - 1)) {
                        dead.add(cand.get(i));
                        cand.get(i).setDead(true);
                        cand.remove(i);
                    }
                } else {
                    s3 += area;
                }
            }
        }
        //JVOLogger.trace("candList.size() = " + cand.size());
        //JVOLogger.trace("deadList.size() = " + dead.size());
        //
        // dead ΰܤ zero ΰ dead ΰȤ롣
        //
        List<CountMap> dead2 = new ArrayList<CountMap>();
        for(int k = 0; k < max; k++) {
            for(int i = cand.size() - 1; i >= 0; i--) {
                for(int j = 0; j < dead.size(); j++) {
                    if(cand.get(i).isNext(dead.get(j))) {
                        cand.get(i).setDead(true);
                        dead2.add(cand.get(i));
                        cand.remove(i);
                        break;
                    }
                }
            }
            dead.addAll(dead2);
            dead2.clear();
        }
        //
        // this.totalArea 򹹿
        //
        s3 = 0;
        for(int i = 0; i < cand.size(); i++) {
            double area = cand.get(i).getArea();
            s3 += area;
        }
        this.totalArea = this.totalArea + s3;
        //
        // this.dead 
        //
        this.dead = dead;
        //
        //
        //
        try {
            //PrintWriter out = JVOFileWriter.open("dead.dat");
            PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("dead.dat")));
             for(int i = 0; i < dead.size(); i++) {
                 out.println(dead.get(i));
             }
             out.close();
        } catch(IOException e) {
        }
    }

    /**
     *  ̩٤ü˹⤤or㤤ΰõ
     *  findDeadRegion() ƤӽФѤ뤳ȡ
     */
    private void findMaskRegion() {
        try {
            List<CountMap> map = this.nonZero;
            if(map == null) {
                map = getNonZeroCountMap();
            }

            int s1 = this.totalCount;
            double s2 = this.totalArea;
            if(s2 <= 0) {
                //JVOLogger.trace("total area is 0");
                return;
            }
            List<CountMap> mask = new ArrayList<CountMap>();
            double density = s1 / s2;
            for(int k = 0; k < 5; k++) {
                for(int i = 0; i < map.size(); i++)  {
                    int count = map.get(i).getCount();
                    double area = map.get(i).getArea();
                    double nexp = density * area;
                    double nupp = nexp + Math.sqrt(nexp) * this.maskSigma;
                    double nlow = nexp - Math.sqrt(nexp) * this.maskSigma;

                    if(count > nupp || count < nlow) {
                        s1 = s1 - count;
                        s2 = s2 - area;
                        if(k == 4) {
                            mask.add(map.get(i));
                        }
                    }
                }
                if(s2 <= 0) {
                    //JVOLogger.trace("total area is 0");
                    return;
                }
                density = s1 / s2;
                s1 = this.totalCount;
                s2 = this.totalArea;
            }
            //
            //
            //
            //PrintWriter out = JVOFileWriter.open("mask.dat");
            PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("mask.dat")));
            for(int i = 0; i < mask.size(); i++) {
                out.println(mask.get(i));
            }
            out.close();
            this.mask = mask;

        } catch(IOException e) {
            //JVOLogger.error("*** error : " + e.getMessage(), e);
        } finally {
        }
    }

    /**
     *
     */
    private void calculateEffectiveArea() {

        PrintWriter out = null;
        try {
            this.badFrac = new double[this.nbin];
            //out = JVOFileWriter.open("sim-dead.dat");
            out = new PrintWriter(new BufferedWriter(new FileWriter("sim-dead.dat")));
            for(int i = 0; i < this.nbin; i++) {
                double th1 = i * step;
                double th2 = (i + 1) * step;

                if(th2 < this.maskRad) {
                    this.maskFrac[i] = 0;
                    continue;
                }
                if(this.maskRad >= th1 && this.maskRad < th2) {
                    th1 = this.maskRad;
                }

                int count = 0;
                for(int j = 0; j < MAX_SIM; j++) {
                    double th1rad = th1 / 60. / 60. / 180. * Math.PI;
                    double th2rad = th2 / 60. / 60. / 180. * Math.PI;
                    double[] pos = simPos(th1rad, th2rad);
                    if(inDeadRegion(pos)) {
                        out.println(pos[0] + " " + pos[1]);
                        count++;
                    }
                }
                this.badFrac[i] = count / (double) MAX_SIM;
                //JVOLogger.trace("i=" + i + " count=" + count);
            }

        } catch(IOException e) {
            
        } finally {
            if(out != null) {
              out.close();
            }
        }
    }

    /**
     *
     */
    private void calculateEffectiveAreaForMask() {

        PrintWriter out = null;
        try {
            this.maskFrac = new double[this.nbin];
            //out = JVOFileWriter.open("sim-mask.dat");
            out = new PrintWriter(new BufferedWriter(new FileWriter("sim-mask.dat")));
            for(int i = 0; i < this.nbin; i++) {
                double th1 = i * step;
                double th2 = (i + 1) * step;
                
                if(th2 < this.maskRad) {
                    this.maskFrac[i] = 0;
                    continue;
                }
                if(this.maskRad >= th1 && this.maskRad < th2) {
                    th1 = this.maskRad;
                }

                int count = 0;
                for(int j = 0; j < MAX_SIM; j++) {
                    double th1rad = th1 / 60. / 60. / 180. * Math.PI;
                    double th2rad = th2 / 60. / 60. / 180. * Math.PI;
                    double[] pos = simPos(th1rad, th2rad);
                    if(inMaskRegion(pos)) {
                        out.println(pos[0] + " " + pos[1]);
                        count++;
                    }
                }
                this.maskFrac[i] = count / (double) MAX_SIM;
            }

        } catch(IOException e) {
            
        } finally {
            if(out != null) {
              out.close();
            }
        }
    }

    /**
     *
     */
    private void output() {
        PrintWriter out = null;
        try {
            //out = JVOFileWriter.open("earea.dat");
            out = new PrintWriter(new BufferedWriter(new FileWriter("earea.dat")));
            out.printf("# bin  rmid    earea    badFrac  count  density  maskFrac\n"); 
            out.printf("# ---  arcsec  arcmin2  ---      ---    arcmn-2  ---\n");

            for(int i = 0; i < this.nbin; i++) {
                //
                //
                //
                double th1 = i * this.step;
                double th2 = (i + 1) * this.step;
                double r = (th1 + th2) * 0.5;
                //
                //
                //
                double maskArea = 0;
                if(th2 < this.maskRad) {
                    maskArea = Math.PI * (th2 * th2 - th1 * th1);
                }
                if(this.maskRad >= th1 && this.maskRad < th2) {
                    maskArea = Math.PI * (this.maskRad * maskRad - th1 * th1);
                }
                //
                //
                //
                double f = this.badFrac[i] + this.maskFrac[i];
                double earea = 
                    (Math.PI * (th2 * th2 - th1 * th1) - maskArea)  * (1 - f);
                earea = earea / 60. / 60.;
                //
                //
                //
                double dens = 0;
                if(earea > 0) {
                    dens = count[i] / earea;
                }
                //
                //String s = i + " " + r + " " + earea + " " + badFrac[i] + " " + count[i] + " " + dens;
                //JVOLogger.trace(s);
                //
                out.printf("%1$4d %2$12.3f %3$14.5e %4$8.4f %5$5d %6$14.5e %7$8.4f\n", 
                           i, r, earea, badFrac[i], count[i], dens, maskFrac[i]);
                out.flush();
            }
        
        } catch(IOException e) {
            
        } finally {
            if(out != null) {
                out.close();
            }
        }

    }


    /**
     * @param th1  radian
     * @param th2  radian
     *
     * @param pos  radian
     */
    private double[] simPos(double th1, double th2) {
        double x = Math.random();
        double y = Math.random();
        double cos1 = Math.cos(th1);
        double cos2 = Math.cos(th2);
        double cos = cos1 - x * (cos1 - cos2);
        double th = Math.acos(cos);
        double ph = Math.PI * 2 * y;
        double[] pos = new double[2];
        
        pos[0] = Math.sin(th) * Math.cos(ph);
        pos[1] = Math.sin(th) * Math.sin(ph);

        return pos;
    }

    /**
     *
     */
    public static void main(String[] argv) throws Exception {
        double ra = Double.parseDouble(argv[0]);
        double dec = Double.parseDouble(argv[1]);
        String file = argv[2];
        //
        // arcsec
        //
        double maskRad = Double.parseDouble(argv[3]);
        //
        // arcsec
        //
        double step = Double.parseDouble(argv[4]);
        //
        // arcsec
        //
        double maskSigma = Double.parseDouble(argv[5]);


        CatalogEffectiveArea op = new CatalogEffectiveArea(ra,dec);
        op.setMaskRad(maskRad);
        op.setStep(step);
        op.setMaskSigma(maskSigma);

        op.read(file);
        op.createCountMap();

        op.findDeadRegion();
        op.findMaskRegion();

        op.calculateEffectiveArea();
        op.calculateEffectiveAreaForMask();
        op.output();

    }


}
